"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.AnimatedStyle = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _Animated = require("./Animated");

var _AnimatedTransform = require("./AnimatedTransform");

var _AnimatedWithChildren2 = require("./AnimatedWithChildren");

var _FlattenStyle = require("./FlattenStyle");

var AnimatedStyle =
/*#__PURE__*/
function (_AnimatedWithChildren) {
  (0, _inherits2.default)(AnimatedStyle, _AnimatedWithChildren);

  function AnimatedStyle(style) {
    var _this;

    (0, _classCallCheck2.default)(this, AnimatedStyle);
    _this = (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(AnimatedStyle).call(this));
    style = (0, _FlattenStyle.FlattenStyle)(style) || {};

    if (style.transform && !(style.transform instanceof _Animated.Animated)) {
      style = (0, _objectSpread2.default)({}, style, {
        transform: new _AnimatedTransform.AnimatedTransform(style.transform)
      });
    }

    _this.style = style;
    return _this;
  }

  (0, _createClass2.default)(AnimatedStyle, [{
    key: "__getValue",
    value: function __getValue() {
      var style = {};

      for (var key in this.style) {
        var value = this.style[key];

        if (value instanceof _Animated.Animated) {
          style[key] = value.__getValue();
        } else {
          style[key] = value;
        }
      }

      return style;
    }
  }, {
    key: "__getAnimatedValue",
    value: function __getAnimatedValue() {
      var style = {};

      for (var key in this.style) {
        var value = this.style[key];

        if (value instanceof _Animated.Animated) {
          style[key] = value.__getAnimatedValue();
        }
      }

      return style;
    }
  }, {
    key: "__attach",
    value: function __attach() {
      for (var key in this.style) {
        var value = this.style[key];

        if (value instanceof _Animated.Animated) {
          value.__addChild(this);
        }
      }
    }
  }, {
    key: "__detach",
    value: function __detach() {
      for (var key in this.style) {
        var value = this.style[key];

        if (value instanceof _Animated.Animated) {
          value.__removeChild(this);
        }
      }
    }
  }]);
  return AnimatedStyle;
}(_AnimatedWithChildren2.AnimatedWithChildren);

exports.AnimatedStyle = AnimatedStyle;
//# sourceMappingURL=AnimatedStyle.js.map