"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.AnimatedTransform = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _Animated = require("./Animated");

var _AnimatedWithChildren2 = require("./AnimatedWithChildren");

var AnimatedTransform =
/*#__PURE__*/
function (_AnimatedWithChildren) {
  (0, _inherits2.default)(AnimatedTransform, _AnimatedWithChildren);

  function AnimatedTransform(transforms) {
    var _this;

    (0, _classCallCheck2.default)(this, AnimatedTransform);
    _this = (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(AnimatedTransform).call(this));
    _this.transforms = transforms;
    return _this;
  }

  (0, _createClass2.default)(AnimatedTransform, [{
    key: "__getValue",
    value: function __getValue() {
      return this.transforms.map(function (transform) {
        var result = {};

        for (var key in transform) {
          var value = transform[key];

          if (value instanceof _Animated.Animated) {
            result[key] = value.__getValue();
          } else {
            result[key] = value;
          }
        }

        return result;
      });
    }
  }, {
    key: "__getAnimatedValue",
    value: function __getAnimatedValue() {
      return this.transforms.map(function (transform) {
        var result = {};

        for (var key in transform) {
          var value = transform[key];

          if (value instanceof _Animated.Animated) {
            result[key] = value.__getAnimatedValue();
          } else {
            // All transform components needed to recompose matrix
            result[key] = value;
          }
        }

        return result;
      });
    }
  }, {
    key: "__attach",
    value: function __attach() {
      var _this2 = this;

      this.transforms.forEach(function (transform) {
        for (var key in transform) {
          var value = transform[key];

          if (value instanceof _Animated.Animated) {
            value.__addChild(_this2);
          }
        }
      });
    }
  }, {
    key: "__detach",
    value: function __detach() {
      var _this3 = this;

      this.transforms.forEach(function (transform) {
        for (var key in transform) {
          var value = transform[key];

          if (value instanceof _Animated.Animated) {
            value.__removeChild(_this3);
          }
        }
      });
    }
  }]);
  return AnimatedTransform;
}(_AnimatedWithChildren2.AnimatedWithChildren);

exports.AnimatedTransform = AnimatedTransform;
//# sourceMappingURL=AnimatedTransform.js.map